<?php
/**
 * VK Media Posts BS4 Config
 *
 * @package VK Media Posts BS4
 */

if ( ! class_exists( 'VK_MEDIA_POSTS_BS4' ) ) {

	define( 'VK_MEDIA_POSTS_BS4_URL', get_template_directory_uri() . '/inc/media-posts-bs4/package/' );
	define( 'VK_MEDIA_POSTS_BS4_DIR', dirname( __FILE__ ) );

	global $system_name;
	$system_name = lightning_get_theme_name();

	global $vk_media_post_prefix;
	$vk_media_post_prefix = lightning_get_prefix();

	global $customize_section_name;
	if ( function_exists( 'lightning_get_prefix_customize_panel' ) ) {
		// 空のパネル名を設定出来るように最後に空白は入れない.
		$customize_section_name = lightning_get_prefix_customize_panel();
	} else {
		$customize_section_name = 'Lightning ';
	}

	global $post_type_info;
	$post_type_info = lightning_get_post_type();

	global $is_extend_loop_name;
	$is_extend_loop_name = 'is_lightning_extend_loop';

	global $do_extend_loop_name;
	$do_extend_loop_name = 'lightning_extend_loop';

	global $vk_mpbs4_archive_layout_class;
	$vk_mpbs4_archive_layout_class = '.mainSection';

	require_once dirname( __FILE__ ) . '/package/class-vk-media-posts-bs4.php';

	/**
	 * Column size setting
	 *
	 * @param array $sizes size of using on media post bs4.
	 */
	function lightning_media_posts_bs4_sizes( $sizes ) {
		unset( $sizes['xxl'] );
		return $sizes;
	}
	add_filter( 'vk_media_post_bs4_size', 'lightning_media_posts_bs4_sizes' );

	/**
	 * Katawara から乗り換えると xxl の設定が残ってしまうので削除する
	 */
	function lightning_delete_xxl() {
		global $pagenow;
		// ダッシュボードのトップページでのみ実行
		if ( $pagenow == 'index.php' ) {
			$vk_post_type_archive = get_option( 'vk_post_type_archive' );
			if ( $vk_post_type_archive && is_array( $vk_post_type_archive ) ) {
				$updated = false;
				foreach ( $vk_post_type_archive as $key => &$values ) {
					if ( isset( $values['col_xxl'] ) ) {
						unset( $values['col_xxl'] ); // col_xxl 項目を削除
						$updated = true;
					}
				}
				if ( $updated ) {
					update_option( 'vk_post_type_archive', $vk_post_type_archive );
				}
			}

		}
	}
	add_action( 'admin_init', 'lightning_delete_xxl' );

	/**
	 * Default Options
	 *
	 * @param array $default_options default options of using on media post bs4.
	 */
	function lightning_media_posts_bs4_default_options( $default_options ) {
		$default_options['layout'] = 'default';
		unset( $default_options['col_xxl'] );
		return $default_options;
	}
	add_filter( 'vk_media_posts_bs4_default_options', 'lightning_media_posts_bs4_default_options' );

	/**
	 * Default Options of Widget
	 *
	 * @param array $default_options default options of using on media post bs4 widget.
	 */
	function lightning_media_posts_bs4_widget_default_options( $default_options ) {
		unset( $default_options['col_xxl'] );
		return $default_options;
	}
	add_filter( 'vk_media_posts_bs4_widget_default_options', 'lightning_media_posts_bs4_widget_default_options' );

	// プリフィックス.
	global $vk_media_post_prefix;
	$vk_media_post_prefix = lightning_get_prefix();
}
